import type { StatsProps as StatsUiComponentProps } from '../ui/Stats';
import type { UseStatsProps } from 'react-instantsearch-hooks';
type UiProps = Pick<StatsUiComponentProps, 'nbHits' | 'nbSortedHits' | 'processingTimeMS' | 'areHitsSorted' | 'translations'>;
export type StatsProps = Omit<StatsUiComponentProps, keyof UiProps> & UseStatsProps & {
    translations?: Partial<UiProps['translations']> & {
        /**
         * @deprecated Use `rootElementText` instead.
         */
        stats?: Partial<UiProps['translations']>['rootElementText'];
    };
};
export declare function Stats({ translations, ...props }: StatsProps): JSX.Element;
export {};
